Minutes from 81st OpenVDB TSC meeting, Feb 23rd, 2021, (EDT)

Attendees: *Ken* M., *Nick* A., *Jeff* L., *Dan* B., *Andre* P.

Additional Attendees: Laura Lediaev (ImageWorks), Bruce Cherniak (Intel), JT Nelson (Blender), Johannes Meng (Intel)

Regrets: none

Agenda:

1) Confirm Quorum
2) Secretary
3) Forum
4) TBB PR
5) SIGGRAPH Submission
6) Morphology PR
7) Filter Tiles
8) Activate/Deactivate Improvement
9) Surfacing and Points Statistics
10) 3D Printing
11) Pending Changes
12) Homework
13) Next meeting

1) Confirm Quorum

Quorum is present.

2) Secretary

Secretary is Andre Pradhana.

3) Forum

Ken will follow up with Tommy Hinks. Ken will also look up the forum post on meshToVolume skipping over small features.

Nick will send a document to explain what to do with the forum/JIRA workflow/github issues tagging.

4) TBB PR

There is a pull request on TBB atomic: moving from tbb atomic to std atomic that is ongoing.

5) SIGGRAPH Submission

Ken has finished the SIGGRAPH submission. SIGGRAPH has a speaker limit, reommending 1-4 speakers. Ken added extension/extrapolation to his slide.  Andre can talk about it if he gets an approval from DWA.

Each person will speak for 45 minutes. Final slides for the course in 11th June 2021. The chair

6) Morphology PR

Morphology PR has gone in. The AX PR has also gone in.

7) Filter Tiles

Filter tiles is PR 843.

8) Activate/Deactivate Improvement

Dan said that the performance of deactivate is about 1.5 times faster because he uses the Dynamic Node Managers because it is parallelizing across tiles generation, so it is breadth-first.

9) Surfacing and Points Statistics

Nick wants to submit a PR on converting points to SDF based on the 2005 SIGGRAPH paper called Animating Sand as a Fluid by Zhu and Bridson. The PR will introduce a duplicate feature to VDB from points and a new kernel as described by the paper.

This PR will introduce a new header for statistics. It allows you to obtain min, max, and average value from VDB Points. It will be called Points Statistics. This is needed for the kernel-rasterization process. The other approach to do this is by doing gather or scatter. Ken mentioned that the quickest way is by coloring the particles in such a way that particles of the same color can be rasterized in parallel. Jeff mentioned that the cost of doing so is in the graph-coloring algorithm. Ideally one wants to run through the graph-coloring algorithm less.

Jeff would like to have a new SOP node associated with this, perhaps VDB Surfacer. Dan and Ken agrees because VDB from Particles SOP also does trail and attribute conversion. The trail functionality is useful to maintain temporal coherency, according to Ken. VDB from Particles is very prevalent.

Dan suggests Nick to split the PR, e.g. by submitting a PR for the new Points Statistics and another for the surfacing. Dan mentions that the Points Statistics can be used in Points Convert SOP. Jeff suggests to use it in a new Points Reduce node.

This PR by Nick will be the isotropic particle surfacer. Ken mentions that an anisotropic surfacer based on the work of Greg Turk can give good result, but one needs to be careful to take into account a missing square-root operator from the paper. Ken also mentions the difficulties of using anisotropic surfacer that arises from high surface curvature. Ken mentions that there are two diverging philosophies in particle skinning: one, where you use a lot of cycles on producing high-quality surface on the points directly (anisotropy is an example of this) and two, where we create a fast and cheap surface using particle stamping and to use filtering techniques after that. The advantage of the second approach is that you can use layering techniques to get improve the surface.

DNEG has a DigiPro presentation on how they have a pipeline that bypass meshes and ray-tracing SDF directly. Ken asks if we want to be able to support this technique. Dan believes that it was used in one particular show.

Ken and Jeff have some discussions about deforming volumes. Jeff argues that deforming a mesh is easier because of the Lagrangian nature of the representation. Volumes can also be deformed, but with a different formulation.

10) 3D Printing

Volume is useful for 3D printing. A lot of people in the forum are from the 3D printing community.

11) Pending Changes

We are switching to Pending Changes as workflow. Dan thinks that it is a better workflow than before. Nick did it because there was a missing change from an external contributor. Resolving conflicts is not a big problem for Nick.

12) Homework

Homework is PR 843 and 978.

13) Next meeting

Next meeting is March 2nd, 2021. 12pm-1pm EST (GMT-5).
