Minutes from 133-rd OpenVDB TSC meeting, May 17th, 2022.

Attendees: *Jeff* L., *Nick* A, *Dan* B., *Ken* M., *Andre* P.

Additional Attendees: Sebastian Gaida, J. T. Nelson (Blender), Peyton Murray,
Sergio Rojas

Regrets: *Rich* J.

Agenda:

1) Confirm quorum
2) Secretary
3) Forum
4) PyPi
5) OpenVDB 9.1 Release
6) Update on Mathematica PR
7) Half support
8) PR-1381: CsgDifferenceOp to immediately prune degenerate tiles
9) Next Meeting

--------------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Andre Pradhana.

3) Forum

a) Issue #1379

The order of grids that you get are different if you use `openvdb::io::File`
than if you use `openvdb::io::Stream`. Nick verified this problem when a user
uses a stream class with delayed loading off. The `openvdb::io::File` API
uses a multimap to store grids of the same name, which is ordered based on
the string names, before being added to a vector of grids. We agreed to add
a new method to either `stream` or `file` that is documented to return grids
in a particular order. We can deprecate the old methods and remove them in
a few years time.

4) PyPi

We are looking at making the python binding for OpenVDB to be published
directly to PyPi. VFX reference platform makes us unable to use the
infrastructure provided by the Python community out of the box. The
solution that Peyton is currently taking is to use `sdist`. A user
will be responsible for building the Python binding. You can still
call `pypi install openvdb`. We do not provide a binary on the host.

Peyton contacted the original package author. The original author agreed
to transfer ownership provided that we credit him. We all agree to do that.

We need an account on PyPi and also a token for the account so we can
automatically upload to the CI. Nick will reach out to John Mertic from ASWF
regarding this.

We thank Peyton for his contributions.

5) OpenVDB 9.1 Release

a) PR-1380

Some fixes for CI and OpenVDB AX on Windows.

b) PR-1363

Changing paths to relative paths. This would be nice to go in.

c) PR-1313 Frustum Rasterization

Dan wants this to get into OpenVDB 9.1. He will address a few notes from
Nick in a separate PR.

d) SOP for Point Rasterization from Nick

Jeff says that this SOP can get into OpenVDB 9.2.

e) Things to go under OpenVDB 10

Greg half and mathematica are aimed at 10. OpenVDB tools
is aimed for OpenVDB 10.

6) Update on Mathematica PR

Greg updated the PR by getting rid of the Mathematica notebooks. Users can
generate these notebooks on the fly.

Greg should have a path to becoming a member of TSC, especially once the
Mathematica link is in OpenVDB.

Ken, Greg, John Mertic, and Nick will have a meeting with a representative
from Wolfram regarding Mathematica later this week.

7) Half support

Ken wants to invite Autodesk to this meeting to talk about their needs and
issues.

8) PR-1381: CsgDifferenceOp to immediately prune degenerate tiles

Jeff added a flag to the raw CsgDifferenceOp to immediately prune degenerate
tiles. When doing CSG SDF Difference on two level-sets that are identical,
canceled tiles are not pruned. They will be pruned if one solves an Eikonal
equation after the CSG operation. Jeff added a flag and a code path two cancel
two tiles if they are all equal in magnitude, but have opposite signs during
CSG Difference Operator. This cancels the tile, instead of writing the absolute
value.

9) Next Meeting

Next meeting is on May 24th, 2022. 1pm-2pm EDT (GMT-4).
