Minutes from 144th OpenVDB TSC meeting, August 30th, 2022, (EDT)

Attendees: *Ken* M., *Andre* P, *Nick* A., *Dan* B., *Rich* J.

Additional Attendees: Greg Hurst (United Therapeutics), Bruce Cherniak (Intel),
Edward Lam (SideFX), Karl Marrett

Regrets: *Jeff* L.

Agenda:

1) Confirm quorum
2) Secretary
3) Forum
4) Windows Compiler Issues
4a) MSVC 2019 fix to PointDataGrid
4b) M_PI missing
4c) MSVC auto issue
5) NanoVDB
6) VDB 10
7) Next meeting

--------------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Dan Bailey

3) Forum

Segmentation Issue. Should only consider the inside surfaces. Fix absolute sign
sweeping back into inside. When to consider smaller pieces part of the main
surface. Nick to put in a PR for further discussion.

4) Windows Compiler Issues

4a) MSVC 2019 fix to PointDataGrid

Bug filed with MSVC. Issue with PointDataGrid goes away in MSVC 2022.

4b) M_PI missing

M_PI is missing when cmath is included before Platform.h. Only an issue on
Windows, M_PI always defined on Linux. It fails with permissive flag enabled,
will need this for future C++ features such as modules. Relying on the include
order to bring in M_PI is bad. Nick wants to remove USE_MATH_DEFINES from
Platform.h.

4c) MSVC auto issue

This was an issue with PointRasterizeTrilinearImpl.h specific to attempting to
derive the type for an auto when using a nested lambda. Nick filed a bug for
this one with MSVC as well.

5) NanoVDB

A PR for NanoVDB is failing due to an issue with byte alignment on the host. Ken
has a good idea how to the fix and will address shortly. The issue results from
the introduction of a C++17 aligned allocator.

6) VDB 10

Ken to push up root node offset work. It works and offers a clear benefit. We
should aim to put it into VDB 10. Question is still how far to go on exposing
it - file format changes, ABI changes, etc?

Active PRs for VDB 10:

* vdb_tool (from Ken)
* Refactor of ValueAccessors (from Nick - PR1452)
* Point Replicate (from Nick - PR1386)

Planned PRs:

* nanovdb improvements (from Ken)
* Fix to shallow tree in NodeManager (from Dan)
* RootNodeMask deletion (from Dan - VDB10?)
* SIMD - add new vectorclass wrapper for performance improvements
  (from Nick/Rich)

7) Next meeting

Next meeting is on September 6th, 2022. 1pm-2pm EDT (GMT-4). Nick will be away
all of September.
