Minutes from 151st OpenVDB TSC meeting, October 18th, 2022

Attendees: *Jeff* L., *Andre* P, *Dan* B., *Rich* J., *Ken* M., *Nick* A.

Additional Attendees: Greg Hurst (United Therapeutics), Sebastian Gaida, Barry Dempsey

Agenda:

1) Confirm quorum
2) Secretary
3) VDB Mathematica Link
4) AX
5) Houdini LZMA
6) ValueAccessor Performance Improvements
7) CMake VDB Tool
8) Next Release
9) Next meeting

------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Dan Bailey.

3) VDB Mathematica Link

Almost ready for this PR to be merged. Documentation still to be finialized. This plugin will not be
built through CI, still waiting for progress there. Question about licensing. One of the 3rd party
dependencies is LTemplate which uses a different license to VDB. MIT License is compatible and does
not do copy left so no further action needed.

4) AX

Nick has looked at LLVM 15, but significant work is needed to support this so this version will
explicitly not be supported in VDB 10.0.

Weekly CI is still failing with a Blosc 1.17 error, if all checks are green seems that we can
disable this error now.

In LLVM 14, a new FMA option which was previously off by default has now been enabled. This is done
at the IR level so will be hard to work around. This is exposed using the fpcontract compiler
flag.

5) Houdini LZMA

Jeff has looked into the LZMA issue in Houdini and confirms the problem that CentOS7 now uses a
different patch version of LZMA to the one that Houdini ships with as a result of the dependency on
boost::iostreams. There are some options, including to extend the LZMA shipped with Houdini to
include the new symbols from the updated CentOS7 version. This issue will go away as users
transition away from CentOS7.

For the CI where this is a problem, we can circumvent this issue by disabling delayed loading which
means boost::iostreams is not used. This is the route we will go for the VDB 10 release to switch
back on the Houdini plugin builds.

6) ValueAccessor Performance Improvements

In addition to the performance improvements, this PR fixes a couple of bugs with adding leaf nodes
through the ValueAccessor. Jeff highlights that some of these changes were proposed in PR1282. Nick
to look over this PR and compare his implementation. One component included in this old PR which is
not present in the new one is the change to fix for adding tiles through the ValueAccessor.

7) CMake VDB Tool

The CMake build for the vdb_tool uses inconsistent names for the CMake variables and does not use
targets for compile options and definitions which risks creating confusing behavior when switching
on this tool as these options will apply to all the subsequent components. Andre to look into
addressing both of these issues before VDB10.

8) Next Release

Continue to look at resolving all the Weekly CI issues and the VDB10 release will be started next
week.

There is a hesitancy to do more frequent releases because the release process is perceived to be
slow. This is something the TSC should re-evaluate based on the ease of doing the VDB10 release.
Only two releases in the 9.x series. Ideally, the next minor release should follow in under six
months.

Dan commits to look at the PointReplicate PR soon after the VDB 10 release.

9) Next meeting

Next meeting is on October 25th, 2022. 2pm-3pm EDT (GMT-4).
