Minutes from OpenVDB TSC meeting, August 27th, 2024

Attendees: *Jeff* L., *Greg* H., *Rich* J, *Ken* M., *Andre* P., *Dan* B.

Regrets: *Nick* A., *Ken* M.

Additional Attendees:
Dhruv Govil (Apple), Jonathan Swartz (NVIDIA), Barry Dempsey

Agenda:

1) Confirm quorum
2) Secretary
3) VDB 12 Release Items
4) License Changes
5) Maintainer List
6) CI Issues
7) PRs to merge
8) Next meeting

------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Jeff Lait.

3) VDB 12 Release Items

a) Half support for v12

Should half grid be a REAL grid?  Ie, should the macros for REAL grid
type include it?  Conclusion was they should not.  Instead a
higher-level named macro should contain Half.

With this decided it is a v12 candidate.  Proxy grid test is
failing, but other than that seems good.  The problem is we can't
instantiate a proxy tree at the moment.

b) fVDB

Will be a feature branch.   Can we have a cadence separate from main VDB?
Can binaries be released on a different place, like Anaconda?  

NanoVDB has a separate release system.  

Tags can be created on branches to mark a release point.

This would require the fVDB release to be based against a stable
version of VDB.  

Currently NanoVDB and fVDB are tightly coupled - improvements to
NanoVDB are coming from fVDB.  This suggests NanoVDB needs to match
fVDB.

4) License Changes

Still trying to set up the second repo to verify CLAs.

5) Maintainer List

Unanimous for changing Committer to Maintainer

Unanimous that it is two maintainers to commit.

Unanimous that all current TSC member are also maintainers.

Unanimous that Jonathan Swartz to be added as a maintainer.

Jeff will attempt to update the relevant policy docs.

6) CI Issues

No good tricks to speed up CI debugging. Can sometimes turn off
unnecessary runners, but some runners just take a long time until the
first possible error.

The secret is for the Houdini download.

cudann download seemed to be failing.  This is likely not from our
runner side.

Need notes for the PR for CI to explain why some of the unusual
solutions are present.

Why certain versions of clang?  This is likely to try to match the g++
of the VFX platform, but we are not sure.  The docker images came from
the ASWF.  We have clang at all to catch more issues than g++ alone.

VDB12 will likely drop support for gcc9.

7) PRs to merge

a) 744 - remove boost any

Someone must approve by next meeting or it will be approved then.

b) 1723 - boost conversion traits

Waiting on the Half PR?  We should take it out of the Half PR so this
can get in, Half PR can rebase on top of the resulting change.

c) 1789, 1775 - Makes adaptive grid easier

1789 is needed so you can use the same Grid with different custom Trees.

1775 explores all possible instantiations and ensures they are handled.

These are both on schedule to be decided on by the next meeting.

8) Next Meeting

Next meeting is on September 10th, 2024. 2pm-3pm EDT (GMT-4).

