Minutes from OpenVDB TSC meeting, September 10th, 2024

Attendees: *Jeff* L., *Rich* J, *Ken* M., *Andre* P., *Dan* B.

Regrets: *Nick* A., *Greg* H.

Additional Attendees:
Dhruv Govil (Apple), Jonathan Swartz (NVIDIA), Francis Williams (NVIDIA), Barry Dempsey

Agenda:

1) Confirm quorum
2) Secretary
3) CCLA
4) Maintainer Change PR (#1883)
5) Approvals for all 5 PRs discussed last meeting
6) fVDB + NanoVDB
7) fVDB Test Files
8) CI Fixes Needed
9) Next Meeting

------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Dan Bailey.

3) CCLA

See John Mertic email about pre-signing the CCLA. Jeff has done this for SideFX already, everyone
else needs to do this so we can switch to the new CCLA.

4) Maintainer Change PR (#1883)

Live review and approval of #1883 to rename "committer" to "maintainer". New TSC members require TSC
votes, all other responsibilities and permissions move to maintainer. Jonathan Swartz added to list
of maintainers and is now a member of ASWF organization. Dan to enable additional permissions for
Jonathan, Francis to go over process with Jonathan to also be made a maintainer.

5) Approvals for all 5 PRs discussed last meeting

a) 744 - remove boost any
b) 1893 - std::is_arithmetic for half
c) 1723 - boost conversion traits (1893 to be merged first)
d) 1789 - move value accessor methods to tree
e) 1775 - update tree adaptor to work with const inputs

With all of these changes merged, boost can officially become an optional dependency of VDB.
Currently, it is a mandatory header-only dependency and requires boost libraries when
delayed-loading is enabled.

6) fVDB + NanoVDB

Currently fVDB is on a feature/fvdb branch. Requires significant improvements to NanoVDB to enable
mutable grids. After discussion, agreed that there should also be a feature/nanovdb branch which is
sporadically merged into feature/fvdb. Expectation that both branches are temporary and when new
functionality considered ready and stable, merged to master, nanovdb first, fvdb second.

7) fVDB Test Files

fVDB test files are currently living in a separate repo. fVDB is built and tested separately, for
improved security, test files are not accessed when built for distribution.

8) CI Fixes Needed

Lots of CI build fixes are needed before VDB12 release. Windows static library build still an
issue.

9) Next Meeting

Next meeting is on September 24th, 2024. 2pm-3pm EDT (GMT-4).
