Minutes from OpenVDB TSC meeting, December 3rd, 2024

Attendees: *Ken* M., *Andre* P, *Dan* B.

Additional Attendees: Jonathan Swartz (NVIDIA), Dhruv Govil (Apple)

Regrets: *Jeff* L., *Richard* J., *Nick* A., *Greg* H.

Agenda:

1) Confirm quorum
2) Secretary
3) PR1971
4) Binary Distribution
5) PR1977
6) Fluid Example
7) TBB Threading
8) ASWF Code Build
9) Next meeting

------------

1) Confirm quorum

No quorum.

2) Secretary

Secretary is Dan Bailey.

3) PR1971

A bug was discovered with vdb_tool that wasn't caught with CI. This has now been
addressed and the CI extended to test this case.

4) Binary Distribution

Brief discussion about binary distribution. Still want to support package
manager maintainers, but hesitant to take this on ourselves. A bigger ROI might
be to focus our efforts on migrating towards CMake config files to make using
OpenVDB as a dependency easier. The autogenerated version.h is a step in that
direction, but could be improved with CMake configs. Other ASWF projects such
as OpenEXR have successfully gone in this direction.

Anaconda integration has been attempted, but is challenging as it only supports
a single library per module by default.

5) PR1977

Dhruv has submitted this PR to address issues with compiling OpenVDB using Clang
19. This new version is stricter and is catching a few valid issues.

6) Fluid Example

All would like this to go in. Andre says that it is blocked on an issue with the
Poisson solver which needs to be resolved. Also, the OpenVDB Remove Divergence
SOP has a bug in how the matrices are initialized that needs to be addressed.

There is a new NanoVDB poisson solver which is of interest to the group. All
agreed that it would potentially be a good fit for NanoVDB. Dan would also
like an example of how to call it directly from OpenVDB.

7) TBB Threading

Question about our use of TBB (#1973). Previously discussed making TBB optional
by wrapping all the data structures and function calls in
openvdb/util/Threading.h. This could provide a route to running
single-threading or providing another threading implementation like Apple's
Grand Central Dispatch. A lot of work needed and not clear how general this
approach would be.

8) ASWF Code Build

Jonathan to reach out to CI working group to try and move this forward to get
GPU runtime testing. Ken can escalate to TSC if need be.

9) Next meeting

Next meeting is Tuesday December 17, 2024 at 11:00 PST. This will be the last
meeting of the year.